import pandas as pd

from collections import Counter
from sklearn import preprocessing
from sklearn import model_selection

# parse Excel '.xls' file
xls = pd.ExcelFile("./titanic3.xls")
# extract first sheet in Excel file
sheet_1 = xls.parse(0)
# count passengers that survived
#counter = Counter(sheet_1["survived"].values)
#print(counter) # prints 'Counter({0: 809, 1: 500})'
#print("survived:",counter[1]) # prints: 'survived: 500'
#print("survival rate:",counter[1]/(counter[1]+counter[0]))
# prints 'survival rate: 0.3819709702062643'
# get the number of passengers with a body tag
# and their survival status
#counter = Counter(sheet_1.loc[sheet_1["body"].notna(),"survived"].values)
#print(counter) # prints: 'Counter({0: 121})''
#print(sheet_1.groupby("pclass")["survived"].mean())
# prints:
# pclass
# 1    0.619195
# 2    0.429603
# 3    0.255289
# Name: survived, dtype: float64
#print(sheet_1.groupby(["pclass","sex"])["survived"].mean())
# prints:
# pclass  sex   
# 1       female    0.965278
#         male      0.340782
# 2       female    0.886792
#         male      0.146199
# 3       female    0.490741
#         male      0.152130
# Name: survived, dtype: float64
#print(sheet_1.count())
# prints:
# pclass       1309
# survived     1309
# name         1309
# sex          1309
# age          1046
# sibsp        1309
# parch        1309
# ticket       1309
# fare         1308
# cabin         295
# embarked     1307
# boat          486
# body          121
# home.dest     745
# dtype: int64
data = sheet_1.drop(["body","cabin","boat","home.dest"], axis=1)
#print(list(data))
# prints: ['pclass', 'survived', 'name', 'sex', 'age',
# 'sibsp', 'parch', 'ticket', 'fare', 'embarked']
data = data.dropna()
#print(data.count())
# prints:
# pclass      1043
# survived    1043
# name        1043
# sex         1043
# age         1043
# sibsp       1043
# parch       1043
# ticket      1043
# fare        1043
# embarked    1043
# dtype: int64
le = preprocessing.LabelEncoder()
data.sex = le.fit_transform(data.sex)
data.embarked = le.fit_transform(data.embarked)
#print(data[:1])
# prints:
#    pclass  survived                           name  sex   age  sibsp  parch  \
# 0       1         1  Allen, Miss. Elisabeth Walton    0  29.0      0      0   
#    ticket      fare  embarked  
# 0   24160  211.3375         2 
data = data.drop(["name", "ticket"], axis=1)
X = data.drop(['survived'], axis=1).values
y = data['survived'].values
X_train, X_test, y_train, y_test = model_selection.train_test_split(X, y, test_size=0.2, shuffle = True)